# OsiMskSolverInterface Class Reference

`#include <OsiMskSolverInterface.hpp>`

Inheritance diagram for OsiMskSolverInterface:
[legend]
Collaboration diagram for OsiMskSolverInterface:
[legend]

List of all members.

## Public Member Functions
virtual void | setObjSense (double s)
| Set objective function sense (1 for min (default), -1 for max,).
virtual void | setColSolution (const double *colsol)
| Set the primal solution column values.
virtual void | setRowPrice (const double *rowprice)
| Set dual solution vector.
const char * | getCtype () const
| return a vector of variable types (continous, binary, integer)
Solve methods
virtual void | initialSolve ()
| Solve initial LP relaxation.
virtual void | resolve ()
| Resolve an LP relaxation after problem modification.
virtual void | branchAndBound ()
| Invoke solver's built-in enumeration algorithm.
Parameter set/get methods
The set methods return true if the parameter was set to the given value, false otherwise. There can be various reasons for failure: the given parameter is not applicable for the solver (e.g., refactorization frequency for the volume algorithm), the parameter is not yet implemented for the solver or simply the value of the parameter is out of the range the solver accepts. If a parameter setting call returns false check the details of your solver. The get methods return true if the given parameter is applicable for the solver and is implemented. In this case the value of the parameter is returned in the second argument. Otherwise they return false.
bool | setIntParam (OsiIntParam key, int value)
| Set an integer parameter.
bool | setDblParam (OsiDblParam key, double value)
| Set a double parameter.
bool | setStrParam (OsiStrParam key, const std::string &value)
| Set a string parameter.
bool | getIntParam (OsiIntParam key, int &value) const
| Get an integer parameter.
bool | getDblParam (OsiDblParam key, double &value) const
| Get a double parameter.
bool | getStrParam (OsiStrParam key, std::string &value) const
| Get a string parameter.
Methods returning info on how the solution process terminated
virtual bool | isAbandoned () const
| Are there a numerical difficulties?
virtual bool | isProvenOptimal () const
| Is optimality proven?
virtual bool | isProvenPrimalInfeasible () const
| Is primal infeasiblity proven?
virtual bool | isProvenDualInfeasible () const
| Is dual infeasiblity proven?
virtual bool | isPrimalObjectiveLimitReached () const
| Is the given primal objective limit reached?
virtual bool | isDualObjectiveLimitReached () const
| Is the given dual objective limit reached?
virtual bool | isIterationLimitReached () const
| Iteration limit reached?
virtual bool | isLicenseError () const
| Has there been a license problem?
int | getRescode () const
| Get rescode return of last Mosek optimizer call.
WarmStart related methods
CoinWarmStart * | getEmptyWarmStart () const
| Get an empty warm start object.
virtual CoinWarmStart * | getWarmStart () const
| Get warmstarting information.
virtual bool | setWarmStart (const CoinWarmStart *warmstart)
| Set warmstarting information.
Hotstart related methods (primarily used in strong branching). <br>
The user can create a hotstart (a snapshot) of the optimization process then reoptimize over and over again always starting from there. NOTE: between hotstarted optimizations only bound changes are allowed.
virtual void | markHotStart ()
| Create a hotstart point of the optimization process.
virtual void | solveFromHotStart ()
| Optimize starting from the hotstart.
virtual void | unmarkHotStart ()
| Delete the snapshot.
Methods related to querying the input data
virtual int | getNumCols () const
| Get number of columns.
virtual int | getNumRows () const
| Get number of rows.
virtual int | getNumElements () const
| Get number of nonzero elements.
virtual const double * | getColLower () const
| Get pointer to array[getNumCols()] of column lower bounds.
virtual const double * | getColUpper () const
| Get pointer to array[getNumCols()] of column upper bounds.
virtual const char * | getRowSense () const
| Get pointer to array[getNumRows()] of row constraint senses.
virtual const double * | getRightHandSide () const
| Get pointer to array[getNumRows()] of rows right-hand sides.
virtual const double * | getRowRange () const
| Get pointer to array[getNumRows()] of row ranges.
virtual const double * | getRowLower () const
| Get pointer to array[getNumRows()] of row lower bounds.
virtual const double * | getRowUpper () const
| Get pointer to array[getNumRows()] of row upper bounds.
virtual const double * | getObjCoefficients () const
| Get pointer to array[getNumCols()] of objective function coefficients.
virtual double | getObjSense () const
| Get objective function sense (1 for min (default), -1 for max).
virtual bool | isContinuous (int colNumber) const
| Return true if column is continuous.
virtual const CoinPackedMatrix * | getMatrixByRow () const
| Get pointer to row-wise copy of matrix.
virtual const CoinPackedMatrix * | getMatrixByCol () const
| Get pointer to column-wise copy of matrix.
virtual double | getInfinity () const
| Get solver's value for infinity.
Methods related to querying the solution
virtual const double * | getColSolution () const
| Get pointer to array[getNumCols()] of primal solution vector.
virtual const double * | getRowPrice () const
| Get pointer to array[getNumRows()] of dual prices.
virtual const double * | getReducedCost () const
| Get a pointer to array[getNumCols()] of reduced costs.
virtual const double * | getRowActivity () const
| Get pointer to array[getNumRows()] of row activity levels (constraint matrix times the solution vector.
virtual double | getObjValue () const
| Get objective function value.
virtual int | getIterationCount () const
| Get how many iterations it took to solve the problem (whatever "iteration" mean to the solver.
virtual std::vector< double * > | getDualRays (int maxNumRays, bool fullRay=false) const
| Get as many dual rays as the solver can provide.
virtual std::vector< double * > | getPrimalRays (int maxNumRays) const
| Get as many primal rays as the solver can provide.
Changing bounds on variables and constraints
virtual void | setObjCoeff (int elementIndex, double elementValue)
| Set an objective function coefficient.
virtual void | setObjCoeffSet (const int *indexFirst, const int *indexLast, const double *coeffList)
| Set a a set of objective function coefficients.
virtual void | setColLower (int elementIndex, double elementValue)
| Set a single column lower bound Use -COIN_DBL_MAX for -infinity.
virtual void | setColUpper (int elementIndex, double elementValue)
| Set a single column upper bound Use COIN_DBL_MAX for infinity.
virtual void | setColBounds (int elementIndex, double lower, double upper)
| Set a single column lower and upper bound The default implementation just invokes `setColLower()` and `setColUpper()`.
virtual void | setColSetBounds (const int *indexFirst, const int *indexLast, const double *boundList)
| Set the bounds on a number of columns simultaneously The default implementation just invokes `setCollower()` and `setColupper()` over and over again.
virtual void | setRowLower (int elementIndex, double elementValue)
| Set a single row lower bound Use -COIN_DBL_MAX for -infinity.
virtual void | setRowUpper (int elementIndex, double elementValue)
| Set a single row upper bound Use COIN_DBL_MAX for infinity.
virtual void | setRowBounds (int elementIndex, double lower, double upper)
| Set a single row lower and upper bound The default implementation just invokes `setRowLower()` and `setRowUpper()`.
virtual void | setRowType (int index, char sense, double rightHandSide, double range)
| Set the type of a single row .
virtual void | setRowSetBounds (const int *indexFirst, const int *indexLast, const double *boundList)
| Set the bounds on a number of rows simultaneously The default implementation just invokes `setRowLower()` and `setRowUpper()` over and over again.
virtual void | setRowSetTypes (const int *indexFirst, const int *indexLast, const char *senseList, const double *rhsList, const double *rangeList)
| Set the type of a number of rows simultaneously The default implementation just invokes `setRowType()` and over and over again.
Integrality related changing methods
virtual void | setContinuous (int index)
| Set the index-th variable to be a continuous variable.
virtual void | setInteger (int index)
| Set the index-th variable to be an integer variable.
virtual void | setContinuous (const int *indices, int len)
| Set the variables listed in indices (which is of length len) to be continuous variables.
virtual void | setInteger (const int *indices, int len)
| Set the variables listed in indices (which is of length len) to be integer variables.
Methods to expand a problem.<br>
Note that if a column is added then by default it will correspond to a continuous variable.
virtual void | addCol (const CoinPackedVectorBase &vec, const double collb, const double colub, const double obj)
| Add a column (primal variable) to the problem.
virtual void | addCols (const int numcols, const CoinPackedVectorBase *const *cols, const double *collb, const double *colub, const double *obj)
| Add a set of columns (primal variables) to the problem.
virtual void | deleteCols (const int num, const int *colIndices)
| Remove a set of columns (primal variables) from the problem.
virtual void | addRow (const CoinPackedVectorBase &vec, const double rowlb, const double rowub)
| Add a row (constraint) to the problem.
virtual void | addRow (const CoinPackedVectorBase &vec, const char rowsen, const double rowrhs, const double rowrng)
| Add a row (constraint) to the problem.
virtual void | addRows (const int numrows, const CoinPackedVectorBase *const *rows, const double *rowlb, const double *rowub)
virtual void | addRows (const int numrows, const CoinPackedVectorBase *const *rows, const char *rowsen, const double *rowrhs, const double *rowrng)
| Add a set of rows (constraints) to the problem.
virtual void | deleteRows (const int num, const int *rowIndices)
| Delete a set of rows (constraints) from the problem.
Methods to input a problem
virtual void | loadProblem (const CoinPackedMatrix &matrix, const double *collb, const double *colub, const double *obj, const double *rowlb, const double *rowub)
| Load in an problem by copying the arguments (the constraints on the rows are given by lower and upper bounds).
virtual void | assignProblem (CoinPackedMatrix *&matrix, double *&collb, double *&colub, double *&obj, double *&rowlb, double *&rowub)
| Load in an problem by assuming ownership of the arguments (the constraints on the rows are given by lower and upper bounds).
virtual void | loadProblem (const CoinPackedMatrix &matrix, const double *collb, const double *colub, const double *obj, const char *rowsen, const double *rowrhs, const double *rowrng)
| Load in an problem by copying the arguments (the constraints on the rows are given by sense/rhs/range triplets).
virtual void | assignProblem (CoinPackedMatrix *&matrix, double *&collb, double *&colub, double *&obj, char *&rowsen, double *&rowrhs, double *&rowrng)
| Load in an problem by assuming ownership of the arguments (the constraints on the rows are given by sense/rhs/range triplets).
virtual void | loadProblem (const int numcols, const int numrows, const int *start, const int *index, const double *value, const double *collb, const double *colub, const double *obj, const double *rowlb, const double *rowub)
| Just like the other loadProblem() methods except that the matrix is given in a standard column major ordered format (without gaps).
virtual void | loadProblem (const int numcols, const int numrows, const int *start, const int *index, const double *value, const double *collb, const double *colub, const double *obj, const char *rowsen, const double *rowrhs, const double *rowrng)
| Just like the other loadProblem() methods except that the matrix is given in a standard column major ordered format (without gaps).
virtual int | readMps (const char *filename, const char *extension="mps")
| Read an mps file from the given filename.
virtual void | writeMps (const char *filename, const char *extension="mps", double objSense=0.0) const
| Write the problem into an mps file of the given filename.
Message handling
void | passInMessageHandler (CoinMessageHandler *handler)
| Pass in a message handler It is the client's responsibility to destroy a message handler installed by this routine; it will not be destroyed when the solver interface is destroyed.
Constructors and destructor
| OsiMskSolverInterface (MSKenv_t mskenv=NULL)
| Default Constructor optional argument mskenv can be used to reach in an initialized user environment OsiMsk assumes membership of mskenv, so it will be freed when the last instanciation of OsiMsk is deleted.
virtual OsiSolverInterface * | clone (bool copyData=true) const
| Clone.
| OsiMskSolverInterface (const OsiMskSolverInterface &)
| Copy constructor.
OsiMskSolverInterface & | operator= (const OsiMskSolverInterface &rhs)
| Assignment operator.
virtual | ~OsiMskSolverInterface ()
| Destructor.
## Static Public Member Functions
Static instance counter methods
static void | incrementInstanceCounter ()
| MOSEK has a context which must be created prior to all other MOSEK calls.
static void | decrementInstanceCounter ()
| MOSEK has a context which should be deleted after MOSEK calls.
static unsigned int | getNumInstances ()
| Return the number of instances of instantiated objects using MOSEK services.
## Public Attributes
Private member data
MSKtask_t | task_
| MOSEK model represented by this class instance.
int * | hotStartCStat_
| Hotstart information.
int | hotStartCStatSize_
| MOSEK model represented by this class instance.
int * | hotStartRStat_
| MOSEK model represented by this class instance.
int | hotStartRStatSize_
| MOSEK model represented by this class instance.
int | hotStartMaxIteration_
| MOSEK model represented by this class instance.
Cached information derived from the MOSEK model
double * | obj_
| Pointer to objective vector.
double * | collower_
| Pointer to dense vector of variable lower bounds.
double * | colupper_
| Pointer to dense vector of variable lower bounds.
char * | rowsense_
| Pointer to dense vector of row sense indicators.
double * | rhs_
| Pointer to dense vector of row right-hand side values.
double * | rowrange_
| Pointer to dense vector of slack upper bounds for range constraints (undefined for non-range rows).
double * | rowlower_
| Pointer to dense vector of row lower bounds.
double * | rowupper_
| Pointer to dense vector of row upper bounds.
double * | colsol_
| Pointer to primal solution vector.
double * | rowsol_
| Pointer to dual solution vector.
double * | redcost_
| Pointer to reduced cost vector.
double * | rowact_
| Pointer to row activity (slack) vector.
CoinPackedMatrix * | matrixByRow_
| Pointer to row-wise copy of problem matrix coefficients.
CoinPackedMatrix * | matrixByCol_
| Pointer to row-wise copy of problem matrix coefficients.
Additional information needed for storing MIP problems
char * | coltype_
| Pointer to dense vector of variable types (continous, binary, integer).
int | coltypesize_
| Size of allocated memory for coltype_.
bool | probtypemip_
| Stores whether MOSEK' prob type is currently set to MIP.
## Protected Member Functions
Protected methods
virtual void | applyRowCut (const OsiRowCut &rc)
| Apply a row cut. Return true if cut was applied.
virtual void | applyColCut (const OsiColCut &cc)
| Apply a column cut (bound adjustment).
## Private Member Functions
Private static class functions
void | switchToLP ()
| switches MOSEK to prob type LP
void | switchToMIP ()
| switches MOSEK to prob type MIP
void | resizeColType (int minsize)
| resizes coltype_ vector to be able to store at least minsize elements
void | freeColType ()
| frees colsize_ vector
bool | definedSolution (int solution) const
| switches MOSEK to prob type LP
int | solverUsed () const
| switches MOSEK to prob type LP
## Static Private Attributes
static unsigned int | numInstances_
| Number of live problem instances.
Private static class data
static MSKenv_t | env_
| MOSEK environment pointer.
## Friends
void | OsiMskSolverInterfaceUnitTest (const std::string &mpsDir, const std::string &netlibDir)
| A function that tests the methods in the OsiMskSolverInterface class.
## MOSEK specific public interfaces
enum | keepCachedFlag { KEEPCACHED_NONE = 0, KEEPCACHED_COLUMN = 1, KEEPCACHED_ROW = 2, KEEPCACHED_MATRIX = 4, KEEPCACHED_RESULTS = 8, KEEPCACHED_PROBLEM = KEEPCACHED_COLUMN | KEEPCACHED_ROW | KEEPCACHED_MATRIX, KEEPCACHED_ALL = KEEPCACHED_PROBLEM | KEEPCACHED_RESULTS, FREECACHED_COLUMN = KEEPCACHED_PROBLEM & ~KEEPCACHED_COLUMN, FREECACHED_ROW = KEEPCACHED_PROBLEM & ~KEEPCACHED_ROW, FREECACHED_MATRIX = KEEPCACHED_PROBLEM & ~KEEPCACHED_MATRIX, FREECACHED_RESULTS = KEEPCACHED_ALL & ~KEEPCACHED_RESULTS }
| Get pointer to MOSEK model and free all specified cached data entries (combined with logical or-operator '|' ):. More...
MSKtask_t | getLpPtr (int keepCached=KEEPCACHED_NONE)
| Get pointer to MOSEK model and free all specified cached data entries (combined with logical or-operator '|' ):.
MSKenv_t | getEnvironmentPtr ()
| Method to access MOSEK environment pointer.
## Private methods
int | Mskerr
| Get task Pointer for const methods.
int | MSKsolverused_
| Get task Pointer for const methods.
double | ObjOffset_
| Get task Pointer for const methods.
int | InitialSolver
| Get task Pointer for const methods.
MSKtask_t | getMutableLpPtr () const
| Get task Pointer for const methods.
void | gutsOfCopy (const OsiMskSolverInterface &source)
| The real work of a copy constructor (used by copy and assignment).
void | gutsOfConstructor ()
| The real work of the constructor.
void | gutsOfDestructor ()
| The real work of the destructor.
void | freeCachedColRim ()
| free cached column rim vectors
void | freeCachedRowRim ()
| free cached row rim vectors
void | freeCachedResults ()
| free cached result vectors
void | freeCachedMatrix ()
| free cached matrices
void | freeCachedData (int keepCached=KEEPCACHED_NONE)
| free all cached data (except specified entries, see getLpPtr())
void | freeAllMemory ()
| free all allocated memory

## Detailed Description

Definition at line 23 of file OsiMskSolverInterface.hpp.

## Member Enumeration Documentation

enum OsiMskSolverInterface::keepCachedFlag

Get pointer to MOSEK model and free all specified cached data entries (combined with logical or-operator '|' ):.

Enumerator:

  KEEPCACHED_NONE | discard all cached data (default)
  KEEPCACHED_COLUMN | column information: objective values, lower and upper bounds, variable types
  KEEPCACHED_ROW | row information: right hand sides, ranges and senses, lower and upper bounds for row
  KEEPCACHED_MATRIX | problem matrix: matrix ordered by column and by row
  KEEPCACHED_RESULTS | LP solution: primal and dual solution, reduced costs, row activities.
  KEEPCACHED_PROBLEM | only discard cached LP solution
  KEEPCACHED_ALL | keep all cached data (similar to getMutableLpPtr())
  FREECACHED_COLUMN | free only cached column and LP solution information
  FREECACHED_ROW | free only cached row and LP solution information
  FREECACHED_MATRIX | free only cached matrix and LP solution information
  FREECACHED_RESULTS | free only cached LP solution information

Definition at line 598 of file OsiMskSolverInterface.hpp.

## Constructor & Destructor Documentation

OsiMskSolverInterface::OsiMskSolverInterface | ( | MSKenv_t | mskenv = `NULL` | ) |

Default Constructor optional argument mskenv can be used to reach in an initialized user environment OsiMsk assumes membership of mskenv, so it will be freed when the last instanciation of OsiMsk is deleted.

OsiMskSolverInterface::OsiMskSolverInterface | ( | const OsiMskSolverInterface & |  | ) |

Copy constructor.

virtual OsiMskSolverInterface::~OsiMskSolverInterface | ( |  | ) | `[virtual]`

Destructor.

## Member Function Documentation

virtual void OsiMskSolverInterface::initialSolve | ( |  | ) | `[virtual]`

Solve initial LP relaxation.

Implements OsiSolverInterface.

virtual void OsiMskSolverInterface::resolve | ( |  | ) | `[virtual]`

Resolve an LP relaxation after problem modification.

Implements OsiSolverInterface.

virtual void OsiMskSolverInterface::branchAndBound | ( |  | ) | `[virtual]`

Invoke solver's built-in enumeration algorithm.

Implements OsiSolverInterface.

bool OsiMskSolverInterface::setIntParam | ( | OsiIntParam | key,
|  | int | value |
| ) |  |  | `[virtual]`

Set an integer parameter.

Reimplemented from OsiSolverInterface.

bool OsiMskSolverInterface::setDblParam | ( | OsiDblParam | key,
|  | double | value |
| ) |  |  | `[virtual]`

Set a double parameter.

Reimplemented from OsiSolverInterface.

bool OsiMskSolverInterface::setStrParam | ( | OsiStrParam | key,
|  | const std::string & | value |
| ) |  |  | `[virtual]`

Set a string parameter.

Reimplemented from OsiSolverInterface.

bool OsiMskSolverInterface::getIntParam | ( | OsiIntParam | key,
|  | int & | value |
| ) |  |  | const`[virtual]`

Get an integer parameter.

Reimplemented from OsiSolverInterface.

bool OsiMskSolverInterface::getDblParam | ( | OsiDblParam | key,
|  | double & | value |
| ) |  |  | const`[virtual]`

Get a double parameter.

Reimplemented from OsiSolverInterface.

bool OsiMskSolverInterface::getStrParam | ( | OsiStrParam | key,
|  | std::string & | value |
| ) |  |  | const`[virtual]`

Get a string parameter.

Reimplemented from OsiSolverInterface.

virtual bool OsiMskSolverInterface::isAbandoned | ( |  | ) | const`[virtual]`

Are there a numerical difficulties?

Implements OsiSolverInterface.

virtual bool OsiMskSolverInterface::isProvenOptimal | ( |  | ) | const`[virtual]`

Is optimality proven?

Implements OsiSolverInterface.

virtual bool OsiMskSolverInterface::isProvenPrimalInfeasible | ( |  | ) | const`[virtual]`

Is primal infeasiblity proven?

Implements OsiSolverInterface.

virtual bool OsiMskSolverInterface::isProvenDualInfeasible | ( |  | ) | const`[virtual]`

Is dual infeasiblity proven?

Implements OsiSolverInterface.

virtual bool OsiMskSolverInterface::isPrimalObjectiveLimitReached | ( |  | ) | const`[virtual]`

Is the given primal objective limit reached?

Reimplemented from OsiSolverInterface.

virtual bool OsiMskSolverInterface::isDualObjectiveLimitReached | ( |  | ) | const`[virtual]`

Is the given dual objective limit reached?

Reimplemented from OsiSolverInterface.

virtual bool OsiMskSolverInterface::isIterationLimitReached | ( |  | ) | const`[virtual]`

Iteration limit reached?

Implements OsiSolverInterface.

virtual bool OsiMskSolverInterface::isLicenseError | ( |  | ) | const`[virtual]`

Has there been a license problem?

int OsiMskSolverInterface::getRescode | ( |  | ) | const`[inline]`

Get rescode return of last Mosek optimizer call.

Definition at line 91 of file OsiMskSolverInterface.hpp.

CoinWarmStart* OsiMskSolverInterface::getEmptyWarmStart | ( |  | ) | const`[virtual]`

Get an empty warm start object.

This routine returns an empty CoinWarmStartBasis object. Its purpose is to provide a way to give a client a warm start basis object of the appropriate type, which can resized and modified as desired.

Implements OsiSolverInterface.

virtual CoinWarmStart* OsiMskSolverInterface::getWarmStart | ( |  | ) | const`[virtual]`

Get warmstarting information.

Implements OsiSolverInterface.

virtual bool OsiMskSolverInterface::setWarmStart | ( | const CoinWarmStart * | warmstart | ) | `[virtual]`

Set warmstarting information.

Return true/false depending on whether the warmstart information was accepted or not.

Implements OsiSolverInterface.

virtual void OsiMskSolverInterface::markHotStart | ( |  | ) | `[virtual]`

Create a hotstart point of the optimization process.

Reimplemented from OsiSolverInterface.

virtual void OsiMskSolverInterface::solveFromHotStart | ( |  | ) | `[virtual]`

Optimize starting from the hotstart.

Reimplemented from OsiSolverInterface.

virtual void OsiMskSolverInterface::unmarkHotStart | ( |  | ) | `[virtual]`

Delete the snapshot.

Reimplemented from OsiSolverInterface.

virtual int OsiMskSolverInterface::getNumCols | ( |  | ) | const`[virtual]`

Get number of columns.

Implements OsiSolverInterface.

virtual int OsiMskSolverInterface::getNumRows | ( |  | ) | const`[virtual]`

Get number of rows.

Implements OsiSolverInterface.

virtual int OsiMskSolverInterface::getNumElements | ( |  | ) | const`[virtual]`

Get number of nonzero elements.

Implements OsiSolverInterface.

virtual const double* OsiMskSolverInterface::getColLower | ( |  | ) | const`[virtual]`

Get pointer to array[getNumCols()] of column lower bounds.

Implements OsiSolverInterface.

virtual const double* OsiMskSolverInterface::getColUpper | ( |  | ) | const`[virtual]`

Get pointer to array[getNumCols()] of column upper bounds.

Implements OsiSolverInterface.

virtual const char* OsiMskSolverInterface::getRowSense | ( |  | ) | const`[virtual]`

Get pointer to array[getNumRows()] of row constraint senses.

- 'L': <= constraint
- 'E': = constraint
- 'G': >= constraint
- 'R': ranged constraint
- 'N': free constraint

Implements OsiSolverInterface.

virtual const double* OsiMskSolverInterface::getRightHandSide | ( |  | ) | const`[virtual]`

Get pointer to array[getNumRows()] of rows right-hand sides.

- if rowsense()[i] == 'L' then rhs()[i] == rowupper()[i]
- if rowsense()[i] == 'G' then rhs()[i] == rowlower()[i]
- if rowsense()[i] == 'R' then rhs()[i] == rowupper()[i]
- if rowsense()[i] == 'N' then rhs()[i] == 0.0

Implements OsiSolverInterface.

virtual const double* OsiMskSolverInterface::getRowRange | ( |  | ) | const`[virtual]`

Get pointer to array[getNumRows()] of row ranges.

- if rowsense()[i] == 'R' then rowrange()[i] == rowupper()[i] - rowlower()[i]
- if rowsense()[i] != 'R' then rowrange()[i] is 0.0

Implements OsiSolverInterface.

virtual const double* OsiMskSolverInterface::getRowLower | ( |  | ) | const`[virtual]`

Get pointer to array[getNumRows()] of row lower bounds.

Implements OsiSolverInterface.

virtual const double* OsiMskSolverInterface::getRowUpper | ( |  | ) | const`[virtual]`

Get pointer to array[getNumRows()] of row upper bounds.

Implements OsiSolverInterface.

virtual const double* OsiMskSolverInterface::getObjCoefficients | ( |  | ) | const`[virtual]`

Get pointer to array[getNumCols()] of objective function coefficients.

Implements OsiSolverInterface.

virtual double OsiMskSolverInterface::getObjSense | ( |  | ) | const`[virtual]`

Get objective function sense (1 for min (default), -1 for max).

Implements OsiSolverInterface.

virtual bool OsiMskSolverInterface::isContinuous | ( | int | colNumber | ) | const`[virtual]`

Return true if column is continuous.

Implements OsiSolverInterface.

virtual const CoinPackedMatrix* OsiMskSolverInterface::getMatrixByRow | ( |  | ) | const`[virtual]`

Get pointer to row-wise copy of matrix.

Implements OsiSolverInterface.

virtual const CoinPackedMatrix* OsiMskSolverInterface::getMatrixByCol | ( |  | ) | const`[virtual]`

Get pointer to column-wise copy of matrix.

Implements OsiSolverInterface.

virtual double OsiMskSolverInterface::getInfinity | ( |  | ) | const`[virtual]`

Get solver's value for infinity.

Implements OsiSolverInterface.

virtual const double* OsiMskSolverInterface::getColSolution | ( |  | ) | const`[virtual]`

Get pointer to array[getNumCols()] of primal solution vector.

Implements OsiSolverInterface.

virtual const double* OsiMskSolverInterface::getRowPrice | ( |  | ) | const`[virtual]`

Get pointer to array[getNumRows()] of dual prices.

Implements OsiSolverInterface.

virtual const double* OsiMskSolverInterface::getReducedCost | ( |  | ) | const`[virtual]`

Get a pointer to array[getNumCols()] of reduced costs.

Implements OsiSolverInterface.

virtual const double* OsiMskSolverInterface::getRowActivity | ( |  | ) | const`[virtual]`

Get pointer to array[getNumRows()] of row activity levels (constraint matrix times the solution vector.

Implements OsiSolverInterface.

virtual double OsiMskSolverInterface::getObjValue | ( |  | ) | const`[virtual]`

Get objective function value.

Implements OsiSolverInterface.

virtual int OsiMskSolverInterface::getIterationCount | ( |  | ) | const`[virtual]`

Get how many iterations it took to solve the problem (whatever "iteration" mean to the solver.

Implements OsiSolverInterface.

virtual std::vector<double*> OsiMskSolverInterface::getDualRays | ( | int | maxNumRays,
|  | bool | fullRay = `false` |
| ) |  |  | const`[virtual]`

Get as many dual rays as the solver can provide.

(In case of proven primal infeasibility there should be at least one.)

The first getNumRows() ray components will always be associated with the row duals (as returned by getRowPrice()). If `fullRay` is true, the final getNumCols() entries will correspond to the ray components associated with the nonbasic variables. If the full ray is requested and the method cannot provide it, it will throw an exception.

NOTE for implementers of solver interfaces:
The double pointers in the vector should point to arrays of length getNumRows() and they should be allocated via new[].

NOTE for users of solver interfaces:
It is the user's responsibility to free the double pointers in the vector using delete[].

Implements OsiSolverInterface.

virtual std::vector<double*> OsiMskSolverInterface::getPrimalRays | ( | int | maxNumRays | ) | const`[virtual]`

Get as many primal rays as the solver can provide.

(In case of proven dual infeasibility there should be at least one.)

NOTE for implementers of solver interfaces:
The double pointers in the vector should point to arrays of length getNumCols() and they should be allocated via new[].

NOTE for users of solver interfaces:
It is the user's responsibility to free the double pointers in the vector using delete[].

Implements OsiSolverInterface.

virtual void OsiMskSolverInterface::setObjCoeff | ( | int | elementIndex,
|  | double | elementValue |
| ) |  |  | `[virtual]`

Set an objective function coefficient.

Implements OsiSolverInterface.

virtual void OsiMskSolverInterface::setObjCoeffSet | ( | const int * | indexFirst,
|  | const int * | indexLast,
|  | const double * | coeffList |
| ) |  |  | `[virtual]`

Set a a set of objective function coefficients.

Reimplemented from OsiSolverInterface.

virtual void OsiMskSolverInterface::setColLower | ( | int | elementIndex,
|  | double | elementValue |
| ) |  |  | `[virtual]`

Set a single column lower bound
Use -COIN_DBL_MAX for -infinity.

Implements OsiSolverInterface.

virtual void OsiMskSolverInterface::setColUpper | ( | int | elementIndex,
|  | double | elementValue |
| ) |  |  | `[virtual]`

Set a single column upper bound
Use COIN_DBL_MAX for infinity.

Implements OsiSolverInterface.

virtual void OsiMskSolverInterface::setColBounds | ( | int | elementIndex,
|  | double | lower,
|  | double | upper |
| ) |  |  | `[virtual]`

Set a single column lower and upper bound
The default implementation just invokes `setColLower()` and `setColUpper()`.

Reimplemented from OsiSolverInterface.

virtual void OsiMskSolverInterface::setColSetBounds | ( | const int * | indexFirst,
|  | const int * | indexLast,
|  | const double * | boundList |
| ) |  |  | `[virtual]`

Set the bounds on a number of columns simultaneously
The default implementation just invokes `setCollower()` and `setColupper()` over and over again.

Parameters:

  | <code>[indexfirst,indexLast]</code> | contains the indices of the constraints whose either bound changes
  | boundList | the new lower/upper bound pairs for the variables

Reimplemented from OsiSolverInterface.

virtual void OsiMskSolverInterface::setRowLower | ( | int | elementIndex,
|  | double | elementValue |
| ) |  |  | `[virtual]`

Set a single row lower bound
Use -COIN_DBL_MAX for -infinity.

Implements OsiSolverInterface.

virtual void OsiMskSolverInterface::setRowUpper | ( | int | elementIndex,
|  | double | elementValue |
| ) |  |  | `[virtual]`

Set a single row upper bound
Use COIN_DBL_MAX for infinity.

Implements OsiSolverInterface.

virtual void OsiMskSolverInterface::setRowBounds | ( | int | elementIndex,
|  | double | lower,
|  | double | upper |
| ) |  |  | `[virtual]`

Set a single row lower and upper bound
The default implementation just invokes `setRowLower()` and `setRowUpper()`.

Reimplemented from OsiSolverInterface.

virtual void OsiMskSolverInterface::setRowType | ( | int | index,
|  | char | sense,
|  | double | rightHandSide,
|  | double | range |
| ) |  |  | `[virtual]`

Set the type of a single row
.

Implements OsiSolverInterface.

virtual void OsiMskSolverInterface::setRowSetBounds | ( | const int * | indexFirst,
|  | const int * | indexLast,
|  | const double * | boundList |
| ) |  |  | `[virtual]`

Set the bounds on a number of rows simultaneously
The default implementation just invokes `setRowLower()` and `setRowUpper()` over and over again.

Parameters:

  | <code>[indexfirst,indexLast]</code> | contains the indices of the constraints whose either bound changes
  | boundList | the new lower/upper bound pairs for the constraints

Reimplemented from OsiSolverInterface.

virtual void OsiMskSolverInterface::setRowSetTypes | ( | const int * | indexFirst,
|  | const int * | indexLast,
|  | const char * | senseList,
|  | const double * | rhsList,
|  | const double * | rangeList |
| ) |  |  | `[virtual]`

Set the type of a number of rows simultaneously
The default implementation just invokes `setRowType()` and over and over again.

Parameters:

  | <code>[indexfirst,indexLast]</code> | contains the indices of the constraints whose type changes
  | senseList | the new senses
  | rhsList | the new right hand sides
  | rangeList | the new ranges

Reimplemented from OsiSolverInterface.

virtual void OsiMskSolverInterface::setContinuous | ( | int | index | ) | `[virtual]`

Set the index-th variable to be a continuous variable.

Implements OsiSolverInterface.

virtual void OsiMskSolverInterface::setInteger | ( | int | index | ) | `[virtual]`

Set the index-th variable to be an integer variable.

Implements OsiSolverInterface.

virtual void OsiMskSolverInterface::setContinuous | ( | const int * | indices,
|  | int | len |
| ) |  |  | `[virtual]`

Set the variables listed in indices (which is of length len) to be continuous variables.

Reimplemented from OsiSolverInterface.

virtual void OsiMskSolverInterface::setInteger | ( | const int * | indices,
|  | int | len |
| ) |  |  | `[virtual]`

Set the variables listed in indices (which is of length len) to be integer variables.

Reimplemented from OsiSolverInterface.

virtual void OsiMskSolverInterface::setObjSense | ( | double | s | ) | `[virtual]`

Set objective function sense (1 for min (default), -1 for max,).

Implements OsiSolverInterface.

virtual void OsiMskSolverInterface::setColSolution | ( | const double * | colsol | ) | `[virtual]`

Set the primal solution column values.

colsol[numcols()] is an array of values of the problem column variables. These values are copied to memory owned by the solver object or the solver. They will be returned as the result of colsol() until changed by another call to setColsol() or by a call to any solver routine. Whether the solver makes use of the solution in any way is solver-dependent.

Implements OsiSolverInterface.

virtual void OsiMskSolverInterface::setRowPrice | ( | const double * | rowprice | ) | `[virtual]`

Set dual solution vector.

rowprice[numrows()] is an array of values of the problem row dual variables. These values are copied to memory owned by the solver object or the solver. They will be returned as the result of rowprice() until changed by another call to setRowprice() or by a call to any solver routine. Whether the solver makes use of the solution in any way is solver-dependent.

Implements OsiSolverInterface.

virtual void OsiMskSolverInterface::addCol | ( | const CoinPackedVectorBase & | vec,
|  | const double | collb,
|  | const double | colub,
|  | const double | obj |
| ) |  |  | `[virtual]`

Add a column (primal variable) to the problem.

Implements OsiSolverInterface.

virtual void OsiMskSolverInterface::addCols | ( | const int | numcols,
|  | const CoinPackedVectorBase *const * | cols,
|  | const double * | collb,
|  | const double * | colub,
|  | const double * | obj |
| ) |  |  | `[virtual]`

Add a set of columns (primal variables) to the problem.

The default implementation simply makes repeated calls to addCol().

Reimplemented from OsiSolverInterface.

virtual void OsiMskSolverInterface::deleteCols | ( | const int | num,
|  | const int * | colIndices |
| ) |  |  | `[virtual]`

Remove a set of columns (primal variables) from the problem.

The solver interface for a basis-oriented solver will maintain valid warm start information if all deleted variables are nonbasic.

Implements OsiSolverInterface.

virtual void OsiMskSolverInterface::addRow | ( | const CoinPackedVectorBase & | vec,
|  | const double | rowlb,
|  | const double | rowub |
| ) |  |  | `[virtual]`

Add a row (constraint) to the problem.

Implements OsiSolverInterface.

virtual void OsiMskSolverInterface::addRow | ( | const CoinPackedVectorBase & | vec,
|  | const char | rowsen,
|  | const double | rowrhs,
|  | const double | rowrng |
| ) |  |  | `[virtual]`

Add a row (constraint) to the problem.

Implements OsiSolverInterface.

virtual void OsiMskSolverInterface::addRows | ( | const int | numrows,
|  | const CoinPackedVectorBase *const * | rows,
|  | const double * | rowlb,
|  | const double * | rowub |
| ) |  |  | `[virtual]`

Add a set of rows (constraints) to the problem.

The default implementation simply makes repeated calls to addRow().

Reimplemented from OsiSolverInterface.

virtual void OsiMskSolverInterface::addRows | ( | const int | numrows,
|  | const CoinPackedVectorBase *const * | rows,
|  | const char * | rowsen,
|  | const double * | rowrhs,
|  | const double * | rowrng |
| ) |  |  | `[virtual]`

Add a set of rows (constraints) to the problem.

The default implementation simply makes repeated calls to addRow().

Reimplemented from OsiSolverInterface.

virtual void OsiMskSolverInterface::deleteRows | ( | const int | num,
|  | const int * | rowIndices |
| ) |  |  | `[virtual]`

Delete a set of rows (constraints) from the problem.

The solver interface for a basis-oriented solver will maintain valid warm start information if all deleted rows are loose.

Implements OsiSolverInterface.

virtual void OsiMskSolverInterface::loadProblem | ( | const CoinPackedMatrix & | matrix,
|  | const double * | collb,
|  | const double * | colub,
|  | const double * | obj,
|  | const double * | rowlb,
|  | const double * | rowub |
| ) |  |  | `[virtual]`

Load in an problem by copying the arguments (the constraints on the rows are given by lower and upper bounds).

If a pointer is 0 then the following values are the default:

- `colub`: all columns have upper bound infinity
- `collb`: all columns have lower bound 0
- `rowub`: all rows have upper bound infinity
- `rowlb`: all rows have lower bound -infinity
- `obj`: all variables have 0 objective coefficient

Implements OsiSolverInterface.

virtual void OsiMskSolverInterface::assignProblem | ( | CoinPackedMatrix *& | matrix,
|  | double *& | collb,
|  | double *& | colub,
|  | double *& | obj,
|  | double *& | rowlb,
|  | double *& | rowub |
| ) |  |  | `[virtual]`

Load in an problem by assuming ownership of the arguments (the constraints on the rows are given by lower and upper bounds).

For default values see the previous method.
WARNING: The arguments passed to this method will be freed using the C++ `delete` and `delete[]` functions.

Implements OsiSolverInterface.

virtual void OsiMskSolverInterface::loadProblem | ( | const CoinPackedMatrix & | matrix,
|  | const double * | collb,
|  | const double * | colub,
|  | const double * | obj,
|  | const char * | rowsen,
|  | const double * | rowrhs,
|  | const double * | rowrng |
| ) |  |  | `[virtual]`

Load in an problem by copying the arguments (the constraints on the rows are given by sense/rhs/range triplets).

If a pointer is 0 then the following values are the default:

- `colub`: all columns have upper bound infinity
- `collb`: all columns have lower bound 0
- `obj`: all variables have 0 objective coefficient
- `rowsen`: all rows are >=
- `rowrhs`: all right hand sides are 0
- `rowrng`: 0 for the ranged rows

Implements OsiSolverInterface.

virtual void OsiMskSolverInterface::assignProblem | ( | CoinPackedMatrix *& | matrix,
|  | double *& | collb,
|  | double *& | colub,
|  | double *& | obj,
|  | char *& | rowsen,
|  | double *& | rowrhs,
|  | double *& | rowrng |
| ) |  |  | `[virtual]`

Load in an problem by assuming ownership of the arguments (the constraints on the rows are given by sense/rhs/range triplets).

For default values see the previous method.
WARNING: The arguments passed to this method will be freed using the C++ `delete` and `delete[]` functions.

Implements OsiSolverInterface.

virtual void OsiMskSolverInterface::loadProblem | ( | const int | numcols,
|  | const int | numrows,
|  | const int * | start,
|  | const int * | index,
|  | const double * | value,
|  | const double * | collb,
|  | const double * | colub,
|  | const double * | obj,
|  | const double * | rowlb,
|  | const double * | rowub |
| ) |  |  | `[virtual]`

Just like the other loadProblem() methods except that the matrix is given in a standard column major ordered format (without gaps).

Implements OsiSolverInterface.

virtual void OsiMskSolverInterface::loadProblem | ( | const int | numcols,
|  | const int | numrows,
|  | const int * | start,
|  | const int * | index,
|  | const double * | value,
|  | const double * | collb,
|  | const double * | colub,
|  | const double * | obj,
|  | const char * | rowsen,
|  | const double * | rowrhs,
|  | const double * | rowrng |
| ) |  |  | `[virtual]`

Just like the other loadProblem() methods except that the matrix is given in a standard column major ordered format (without gaps).

Implements OsiSolverInterface.

virtual int OsiMskSolverInterface::readMps | ( | const char * | filename,
|  | const char * | extension = `"mps"` |
| ) |  |  | `[virtual]`

Read an mps file from the given filename.

Reimplemented from OsiSolverInterface.

virtual void OsiMskSolverInterface::writeMps | ( | const char * | filename,
|  | const char * | extension = `"mps"`,
|  | double | objSense = `0.0` |
| ) |  |  | const`[virtual]`

Write the problem into an mps file of the given filename.

If objSense is non zero then -1.0 forces the code to write a maximization objective and +1.0 to write a minimization one. If 0.0 then solver can do what it wants

Implements OsiSolverInterface.

void OsiMskSolverInterface::passInMessageHandler | ( | CoinMessageHandler * | handler | ) | `[virtual]`

Pass in a message handler It is the client's responsibility to destroy a message handler installed by this routine; it will not be destroyed when the solver interface is destroyed.

Reimplemented from OsiSolverInterface.

MSKtask_t OsiMskSolverInterface::getLpPtr | ( | int | keepCached = `KEEPCACHED_NONE` | ) |

Get pointer to MOSEK model and free all specified cached data entries (combined with logical or-operator '|' ):.

MSKenv_t OsiMskSolverInterface::getEnvironmentPtr | ( |  | ) |

Method to access MOSEK environment pointer.

const char* OsiMskSolverInterface::getCtype | ( |  | ) | const

return a vector of variable types (continous, binary, integer)

static void OsiMskSolverInterface::incrementInstanceCounter | ( |  | ) | `[static]`

MOSEK has a context which must be created prior to all other MOSEK calls.

This method:

- Increments by 1 the number of uses of the MOSEK environment.
- Creates the MOSEK context when the number of uses is change to 1 from 0.

static void OsiMskSolverInterface::decrementInstanceCounter | ( |  | ) | `[static]`

MOSEK has a context which should be deleted after MOSEK calls.

This method:

- Decrements by 1 the number of uses of the MOSEK environment.
- Deletes the MOSEK context when the number of uses is change to 0 from 1.

static unsigned int OsiMskSolverInterface::getNumInstances | ( |  | ) | `[static]`

Return the number of instances of instantiated objects using MOSEK services.

virtual OsiSolverInterface* OsiMskSolverInterface::clone | ( | bool | copyData = `true` | ) | const`[virtual]`

Clone.

Implements OsiSolverInterface.

OsiMskSolverInterface& OsiMskSolverInterface::operator= | ( | const OsiMskSolverInterface & | rhs | ) |

Assignment operator.

Reimplemented from OsiSolverInterface.

virtual void OsiMskSolverInterface::applyRowCut | ( | const OsiRowCut & | rc | ) | `[protected, virtual]`

Apply a row cut. Return true if cut was applied.

Implements OsiSolverInterface.

virtual void OsiMskSolverInterface::applyColCut | ( | const OsiColCut & | cc | ) | `[protected, virtual]`

Apply a column cut (bound adjustment).

Return true if cut was applied.

Implements OsiSolverInterface.

void OsiMskSolverInterface::switchToLP | ( |  | ) | `[private]`

switches MOSEK to prob type LP

void OsiMskSolverInterface::switchToMIP | ( |  | ) | `[private]`

switches MOSEK to prob type MIP

void OsiMskSolverInterface::resizeColType | ( | int | minsize | ) | `[private]`

resizes coltype_ vector to be able to store at least minsize elements

void OsiMskSolverInterface::freeColType | ( |  | ) | `[private]`

frees colsize_ vector

bool OsiMskSolverInterface::definedSolution | ( | int | solution | ) | const`[private]`

switches MOSEK to prob type LP

int OsiMskSolverInterface::solverUsed | ( |  | ) | const`[private]`

switches MOSEK to prob type LP

MSKtask_t OsiMskSolverInterface::getMutableLpPtr | ( |  | ) | const

Get task Pointer for const methods.

void OsiMskSolverInterface::gutsOfCopy | ( | const OsiMskSolverInterface & | source | ) |

The real work of a copy constructor (used by copy and assignment).

void OsiMskSolverInterface::gutsOfConstructor | ( |  | ) |

The real work of the constructor.

void OsiMskSolverInterface::gutsOfDestructor | ( |  | ) |

The real work of the destructor.

void OsiMskSolverInterface::freeCachedColRim | ( |  | ) |

free cached column rim vectors

void OsiMskSolverInterface::freeCachedRowRim | ( |  | ) |

free cached row rim vectors

void OsiMskSolverInterface::freeCachedResults | ( |  | ) |

free cached result vectors

void OsiMskSolverInterface::freeCachedMatrix | ( |  | ) |

free cached matrices

void OsiMskSolverInterface::freeCachedData | ( | int | keepCached = `KEEPCACHED_NONE` | ) |

free all cached data (except specified entries, see getLpPtr())

void OsiMskSolverInterface::freeAllMemory | ( |  | ) |

free all allocated memory

## Friends And Related Function Documentation

void OsiMskSolverInterfaceUnitTest | ( | const std::string & | mpsDir,
|  | const std::string & | netlibDir |
| ) |  |  | `[friend]`

A function that tests the methods in the OsiMskSolverInterface class.

## Member Data Documentation

MSKenv_t OsiMskSolverInterface::env_`[static, private]`

MOSEK environment pointer.

Definition at line 717 of file OsiMskSolverInterface.hpp.

unsigned int OsiMskSolverInterface::numInstances_`[static, private]`

Number of live problem instances.

Definition at line 722 of file OsiMskSolverInterface.hpp.

int OsiMskSolverInterface::Mskerr`[private]`

Get task Pointer for const methods.

Definition at line 727 of file OsiMskSolverInterface.hpp.

int OsiMskSolverInterface::MSKsolverused_`[private]`

Get task Pointer for const methods.

Definition at line 728 of file OsiMskSolverInterface.hpp.

double OsiMskSolverInterface::ObjOffset_`[private]`

Get task Pointer for const methods.

Definition at line 729 of file OsiMskSolverInterface.hpp.

int OsiMskSolverInterface::InitialSolver`[private]`

Get task Pointer for const methods.

Definition at line 731 of file OsiMskSolverInterface.hpp.

MSKtask_t OsiMskSolverInterface::task_`[mutable]`

MOSEK model represented by this class instance.

Definition at line 766 of file OsiMskSolverInterface.hpp.

int* OsiMskSolverInterface::hotStartCStat_

Hotstart information.

Definition at line 769 of file OsiMskSolverInterface.hpp.

int OsiMskSolverInterface::hotStartCStatSize_

MOSEK model represented by this class instance.

Definition at line 770 of file OsiMskSolverInterface.hpp.

int* OsiMskSolverInterface::hotStartRStat_

MOSEK model represented by this class instance.

Definition at line 771 of file OsiMskSolverInterface.hpp.

int OsiMskSolverInterface::hotStartRStatSize_

MOSEK model represented by this class instance.

Definition at line 772 of file OsiMskSolverInterface.hpp.

int OsiMskSolverInterface::hotStartMaxIteration_

MOSEK model represented by this class instance.

Definition at line 773 of file OsiMskSolverInterface.hpp.

double* OsiMskSolverInterface::obj_`[mutable]`

Pointer to objective vector.

Definition at line 778 of file OsiMskSolverInterface.hpp.

double* OsiMskSolverInterface::collower_`[mutable]`

Pointer to dense vector of variable lower bounds.

Definition at line 781 of file OsiMskSolverInterface.hpp.

double* OsiMskSolverInterface::colupper_`[mutable]`

Pointer to dense vector of variable lower bounds.

Definition at line 784 of file OsiMskSolverInterface.hpp.

char* OsiMskSolverInterface::rowsense_`[mutable]`

Pointer to dense vector of row sense indicators.

Definition at line 787 of file OsiMskSolverInterface.hpp.

double* OsiMskSolverInterface::rhs_`[mutable]`

Pointer to dense vector of row right-hand side values.

Definition at line 790 of file OsiMskSolverInterface.hpp.

double* OsiMskSolverInterface::rowrange_`[mutable]`

Pointer to dense vector of slack upper bounds for range constraints (undefined for non-range rows).

Definition at line 793 of file OsiMskSolverInterface.hpp.

double* OsiMskSolverInterface::rowlower_`[mutable]`

Pointer to dense vector of row lower bounds.

Definition at line 796 of file OsiMskSolverInterface.hpp.

double* OsiMskSolverInterface::rowupper_`[mutable]`

Pointer to dense vector of row upper bounds.

Definition at line 799 of file OsiMskSolverInterface.hpp.

double* OsiMskSolverInterface::colsol_`[mutable]`

Pointer to primal solution vector.

Definition at line 802 of file OsiMskSolverInterface.hpp.

double* OsiMskSolverInterface::rowsol_`[mutable]`

Pointer to dual solution vector.

Definition at line 805 of file OsiMskSolverInterface.hpp.

double* OsiMskSolverInterface::redcost_`[mutable]`

Pointer to reduced cost vector.

Definition at line 808 of file OsiMskSolverInterface.hpp.

double* OsiMskSolverInterface::rowact_`[mutable]`

Pointer to row activity (slack) vector.

Definition at line 811 of file OsiMskSolverInterface.hpp.

CoinPackedMatrix* OsiMskSolverInterface::matrixByRow_`[mutable]`

Pointer to row-wise copy of problem matrix coefficients.

Definition at line 814 of file OsiMskSolverInterface.hpp.

CoinPackedMatrix* OsiMskSolverInterface::matrixByCol_`[mutable]`

Pointer to row-wise copy of problem matrix coefficients.

Definition at line 817 of file OsiMskSolverInterface.hpp.

char* OsiMskSolverInterface::coltype_

Pointer to dense vector of variable types (continous, binary, integer).

Definition at line 823 of file OsiMskSolverInterface.hpp.

int OsiMskSolverInterface::coltypesize_

Size of allocated memory for coltype_.

Definition at line 826 of file OsiMskSolverInterface.hpp.

bool OsiMskSolverInterface::probtypemip_`[mutable]`

Stores whether MOSEK' prob type is currently set to MIP.

Definition at line 829 of file OsiMskSolverInterface.hpp.

The documentation for this class was generated from the following file:

- /home/coin/svn-release/Alps-1.4.5/Osi/src/OsiMsk/OsiMskSolverInterface.hpp